<?php

namespace ZVLib\api;

class SsoToken
{
    const LIFETIME = 10800;

    public static function make($domain, $secretKey, $username, $email, $fname = null, $mname = null, $lname = null,
                                $did = null, $pid = null, $page = null)
    {
        $header = ["typ" => "JWT", "alg" => "HS256", "jti" => "ZNANIUM-JWT"];
        $payload = array_merge(
            [
                "iss" => "https://znanium.com",
                "aud" => "https://znanium.com",
                "jti" => "ZNANIUM-JWT",
                "iat" => time(),
                "exp" => time() + self::LIFETIME
            ],
            compact('domain', 'username', 'email', 'fname', 'mname', 'lname', 'did', 'pid', 'page')
        );

        $token = base64_encode(json_encode($header)) . '.' . base64_encode(json_encode($payload));
        $signature = base64_encode(hash_hmac('sha256', $token, $secretKey, true));
        $token .= ".{$signature}";

        return $token;
    }
}